SystemOrganization addCategory: 'Orbeon_Persistence_API'!

BaselineOf subclass: #BaselineOfOrbeonPersistenceApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Persistence_API'!

WARestfulHandler subclass: #WAOrbeonPersistenceApiService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Persistence_API'!

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/17/2015 15:33'!
applyQueryToFormDefinition: xmlDocument
	| queryNodes queryFields result |

	queryFields  := Dictionary new.
	result := Orbeon_Form_Data getAllFormDefinitions select: [:each | each deleted = 'N'].

	queryNodes := (xmlDocument allElementsNamed: 'query') do: [:node | 
		node strings notEmpty ifTrue: [queryFields at: (node attributeAt: 'name') put: node strings last]].

	queryFields keysAndValuesDo: [:key :value |
		(key = 'application-name') ifTrue: [result := result select: [:each | each app = (queryFields at: 'application-name')]].
		(key = 'form-name') ifTrue: [result := result select: [:each | each form = (queryFields at: 'form-name')]].
		(key = 'title') ifTrue: [result := result select: [:each | each title = (queryFields at: 'title')]].
		(key = 'description') ifTrue: [result := result select: [:each | each description = (queryFields at: 'description')]].
	].

	^result! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/17/2015 14:55'!
applyQueryToFormInstance: instances queryNodes: collectionOfOrbeonQueryNode
	|  query |

	query := collectionOfOrbeonQueryNode select: [:each | each isSearchAndHasValue].

	^(instances select: [:each | each satisfyQuery: query]) asOrderedCollection! !

!WAOrbeonPersistenceApiService methodsFor: 'service-delete' stamp: 'BrunoBB 08/21/2015 11:07'!
deleteFormDefinitionWithId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| orbeonInstance |
	<delete>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	Orbeon_Form_Data logicalRemoveFormDefinitionWithId: id ifAbsent: []! !

!WAOrbeonPersistenceApiService methodsFor: 'service-delete' stamp: 'BrunoBB 08/21/2015 11:07'!
deleteFormDraft: formName app: app withId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| orbeonInstance |
	<delete>
	<path: '/crud/{2}/{1}/draft/{3}/data.xml'>

	Orbeon_Form_Data removeFormDraftWithId: id form: formName app: app ifAbsent: []! !

!WAOrbeonPersistenceApiService methodsFor: 'service-delete' stamp: 'BrunoBB 08/21/2015 11:09'!
deleteFormInstance: formName app: app withId: id
	"This method is called by Orbeon when a user click -Send- in a Form Instance page"
	| orbeonInstance |
	<delete>
	<path: '/crud/{2}/{1}/data/{3}/data.xml'>

	Orbeon_Form_Data logicalRemoveFormInstanceWithId: id ifAbsent: []! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/10/2015 13:17'!
duplicateFormDefinitionNewId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| orbeonInstance |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	orbeonInstance := Orbeon_Form_Data new.

	orbeonInstance xml: self requestContext request rawBody;
		isDefinition: true;
		document_id: id;
		setMetadata;
		form_version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		updateLastModifiedTime;
		addToStorage.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/10/2015 14:02'!
duplicateFormInstance: formName app: app newId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| orbeonInstance |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml'>

	orbeonInstance := Orbeon_Form_Data new.

	orbeonInstance xml: self requestContext request rawBody;
		app: app;
		form: formName;
		document_id: id;
		form_version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		updateLastModifiedTime;
		addToStorage.! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/17/2015 15:03'!
generateXmlAnswerFor: formDefinition summary: instanceCollection withQueryNodes: collectionOfOrbeonQueryNode user: username group: group searchTotal: searchTotal
	| xmlWriter summaryFields |

	xmlWriter := XMLWriter new.
	summaryFields := collectionOfOrbeonQueryNode select: [:each | each isSummary] thenCollect: [:each | each name].

	xmlWriter writeWith: [:writer | | tag |
		tag := writer tag: 'documents' attributes: (self getArrayOfOrbeonHeadersFor: instanceCollection searchTotal: searchTotal).
		tag with: [instanceCollection do: [:each | self generateXmlNodeFor: each definition: formDefinition summary: summaryFields with: writer user: username group: group]].
	].

	 ^xmlWriter contents! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/17/2015 15:36'!
generateXmlAnswerForBuilderSummary: definitionCollection searchTotal: searchTotal
	| xmlWriter |

	xmlWriter := XMLWriter new.

	xmlWriter writeWith: [:writer | | tag |
		tag := writer tag: 'documents' attributes: (self getArrayOfOrbeonHeadersFor: definitionCollection searchTotal: searchTotal).
		tag with: [definitionCollection do: [:each | self generateXmlNodeForDefinition: each with: writer]].
	].

	 ^xmlWriter contents! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/16/2015 16:50'!
generateXmlNodeFor: anOrbeon_Form_Data definition: formDefinition summary: collectionOfNames with: aXMLWriter user: username group: group
	| nodeAttributes tag |

	nodeAttributes := OrderedCollection new
		add: 'created' -> anOrbeon_Form_Data created asOrbeonDateTimeString;
		add: 'draft' -> anOrbeon_Form_Data printDraft;
		add: 'last-modified' -> anOrbeon_Form_Data last_modified_time asOrbeonDateTimeString;
		add: 'name' -> anOrbeon_Form_Data document_id;
		add: 'operations' -> (self getPermissionsFor: anOrbeon_Form_Data user: username group: group in: formDefinition);
		asArray.

	tag := aXMLWriter tag: 'document' attributes: nodeAttributes.

	tag with: [aXMLWriter 
						tag: 'details' 
						with: [(anOrbeon_Form_Data getValueOfFields: collectionOfNames) 
									do: [:each | aXMLWriter tag: 'detail' with: each]]].! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/15/2015 15:58'!
generateXmlNodeForDefinition: anOrbeon_Form_Data with: aXMLWriter
	| nodeAttributes tag |

	nodeAttributes := OrderedCollection new
		add: 'created' -> anOrbeon_Form_Data created asOrbeonDateTimeString;
		add: 'draft' -> anOrbeon_Form_Data printDraft;
		add: 'last-modified' -> anOrbeon_Form_Data last_modified_time asOrbeonDateTimeString;
		add: 'name' -> anOrbeon_Form_Data document_id;
		add: 'operations' -> '*';
		asArray.

	tag := aXMLWriter tag: 'document' attributes: nodeAttributes.

	tag with: [aXMLWriter tag: 'details' 
									with: [aXMLWriter tag: 'detail' with: anOrbeon_Form_Data app.
											aXMLWriter tag: 'detail' with: anOrbeon_Form_Data form.
											aXMLWriter tag: 'detail' with: anOrbeon_Form_Data title.
											aXMLWriter tag: 'detail' with: anOrbeon_Form_Data description.]]! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/17/2015 15:03'!
getArrayOfOrbeonHeadersFor: anOrderedCollection searchTotal: searchTotal

	^OrderedCollection new
		add: 'xmlns:ev' -> 'http://www.w3.org/2001/xml-events';
		add: 'xmlns:f' -> 'http//www.orbeon.com/function';
		add: 'xmlns:frf' -> 'java:org.orbeon.oxf.fr.FormRunner';
		add: 'xmlns:odt' -> 'http://orbeon.org/oxf/xml/datatypes';
		add: 'xmlns:oxf' -> 'http://www.orbeon.com/oxf/processors';
		add: 'xmlns:p' -> 'http://www.orbeon.com/oxf/pipeline';
		add: 'xmlns:saxon' -> 'http://saxon.sf.net/';
		add: 'xmlns:sql' -> 'http://orbeon.org/oxf/xml/sql';
		add: 'xmlns:xf' -> 'http://www.w3.org/2002/xforms';
		add: 'xmlns:xi' -> 'http://www.w3.org/2001/XInclude';
		add: 'xmlns:xpl' -> 'java:org.orbeon.oxf.pipeline.api.FunctionLibrary';
		add: 'xmlns:xs' -> 'http://www.w3.org/2001/XMLSchema';
		add: 'xmlns:xxf' -> 'http://orbeon.org/oxf/xml/xforms';
		add: 'page-size' -> '10';
		add: 'total' -> Orbeon_Form_Data totalSize printString;
		add: 'search-total' -> searchTotal printString;
		asArray! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/24/2015 10:53'!
getDefinitionForFormInstanceWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page (or go directly to edit/view page of a form). The Summary then open the Form Instance in it's corresponding form definition.
	This service is used in combination of #getXmlOfFormInstanceWithId:form:app: to <get> the actual data of the form"
	| orbeonDefinition latestVersionNumber |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/form/form.xhtml?document={1}'>

	orbeonDefinition := Orbeon_Form_Definition getLatestFormDefinition: form app: app.
	latestVersionNumber := Orbeon_Form_Definition getLatestFormDefinitionVersion: form app: app.

	self requestContext response headerAt: 'orbeon-form-definition-version' put: latestVersionNumber printString.

	^((GRCodec forEncoding: 'utf-8') decode: orbeonDefinition xml) asString! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/17/2015 13:47'!
getFormDefinitionWithId: id 
	"This service is called when a click is performed on the Orbeon Form Builder Summary page.
	The Summary then should open the Orbeon Builder with the code of the clicked form."
	| orbeonData |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	^((GRCodec forEncoding: 'utf-8') decode: (Orbeon_Form_Data getFormDefinitionWithId: id) xml) asString! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/17/2015 13:58'!
getFormVersion: formName app: app 
	"This method is called by Orbeon when a Form Definition (inside the Builder) is about to be Published.
	This method answer the latest version of the form definition <formName> in application <app>.
	Using the header <orbeon-form-definition-version> to set the version number.
	It also called when a new Form Instance page is about to be displayed (app/form/new)"
	| latestVersionNumber |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml'>

	latestVersionNumber := Orbeon_Form_Definition getLatestFormDefinitionVersion: formName app: app.

	self requestContext response headerAt: 'orbeon-form-definition-version' put: latestVersionNumber printString.

	^((GRCodec forEncoding: 'utf-8') decode: (Orbeon_Form_Definition getLatestFormDefinition: formName app: app) xml) asString! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/16/2015 15:15'!
getInstancesTypeFrom: xmlDocument for: username inGroup: group forForm: formName in: app
	| draftsNodes draftNode |

	draftsNodes := xmlDocument descendentElementsNamed: 'drafts'.
	draftsNodes isEmpty ifTrue: [^self getValidInstancesFor: username group: group inForm: formName in: app].

	draftNode := draftsNodes first.
	(((draftNode attributeAt: 'for-never-saved-document') = 'true') and: [draftNode contentString = 'only'])
	ifTrue: [^self getValidDraftsFor: username group: group inForm: formName in: app].

	^self getValidInstancesFor: username group: group inForm: formName in: app! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/21/2015 10:41'!
getOrbeonFr
	"This service is called when accessing Form Runner Home: ../orbeon/fr/ "
	| xmlWriter |
	<get>
	<produces: 'application/xml'>
	<path: '/form'>

	xmlWriter := XMLWriter new.
	xmlWriter writeWith: [:writer | | tag | 
		writer tag: 'forms' with: [Orbeon_Form_Definition getAllLatestFormDefinitions do: [:eachDef | 
			self getXmlNodeFor: eachDef with: writer]].
	].

	^xmlWriter contents! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/17/2015 14:49'!
getPageNumberFrom: xmlDocument
	| pageNumberNodes pageNumberNode |

	pageNumberNodes := xmlDocument allElementsNamed: 'page-number'.
	pageNumberNodes isEmpty ifTrue: [^1].

	pageNumberNode := pageNumberNodes last.
	pageNumberNode strings isEmpty ifTrue: [^1].

	^Number fromString: pageNumberNode strings last! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/17/2015 14:49'!
getPageSizeFrom: xmlDocument
	| pageSizeNodes pageSizeNode |

	pageSizeNodes := xmlDocument allElementsNamed: 'page-size'.
	pageSizeNodes isEmpty ifTrue: [^10].

	pageSizeNode := pageSizeNodes last.
	pageSizeNode strings isEmpty ifTrue: [^10].

	^Number fromString: pageSizeNode strings last! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/16/2015 16:47'!
getPermissionsFor: anOrbeon_Form_Data user: username group: group in: formDefinition
	| printStream |

	printStream := PrintStream on: String new.

	((anOrbeon_Form_Data hasUser: username createAccessUsing: formDefinition permissions) 
	or: [anOrbeon_Form_Data hasRole: group createAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'create '].

	((anOrbeon_Form_Data hasUser: username readAccessUsing: formDefinition permissions) 
	or: [anOrbeon_Form_Data hasRole: group readAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'read '].

	((anOrbeon_Form_Data hasUser: username updateAccessUsing: formDefinition permissions) 
	or: [anOrbeon_Form_Data hasRole: group updateAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'update '].

	((anOrbeon_Form_Data hasUser: username deleteAccessUsing: formDefinition permissions) 
	or: [anOrbeon_Form_Data hasRole: group deleteAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'delete '].

	^printStream contents! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/16/2015 15:02'!
getQueryNodesFrom: xmlDocument
	"The receiver extract the -query nodes- from the XML Document <xmlDocument>.
	These -query nodes- are used to query the Orbeon Summary and to show summary fields"
	| queryNodes |

	queryNodes := OrderedCollection new.

	(xmlDocument allElementsNamed: 'query') do: [:node | | queryNode value |
		value := node strings notEmpty ifTrue: [node strings last] ifFalse: [nil].
		queryNode := OrbeonQueryNode new name: (node attributeAt: 'name');
								path: (node attributeAt: 'path');
								type: (node attributeAt: 'type');
								control: (node attributeAt: 'control');
								searchField: (node attributeAt: 'search-field'); 
								summaryField: (node attributeAt: 'summary-field'); 
								match: (node attributeAt: 'match'); 
								value: value;
								yourself.
		queryNodes add: queryNode.
		].

	^queryNodes! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/16/2015 15:20'!
getValidDraftsFor: username group: group inForm: formName in: app
	"Answer a collection of valid drafts for the form <formName> in application <app> for the current user <username> that belongs to the group <group>.
	For more details: https://github.com/orbeon/orbeon-forms/wiki/Form-Runner-~-Autosave"
	| definition |

	definition := Orbeon_Form_Definition getLatestFormDefinition: formName app: app.

	^((Orbeon_Form_Data getFormDraftsOf: formName in: app) 
			select: [:each | (each hasUser: username readAccessUsing: definition permissions) 
										or: [each hasRole: group readAccessUsing: definition permissions]])! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/16/2015 15:11'!
getValidInstancesFor: username group: group inForm: formName in: app
	"Answer a collection of valid instances for the form <formName> in application <app> for the current user <username> that belongs to the group <group>"
	| definition |

	definition := Orbeon_Form_Definition getLatestFormDefinition: formName app: app.

	^((Orbeon_Form_Data getFormInstancesOf: formName in: app) 
			select: [:each | each deleted = 'N' and: [(each hasUser: username readAccessUsing: definition permissions) 
																	or: [each hasRole: group readAccessUsing: definition permissions]]]) 
		addAll:
		((Orbeon_Form_Data getFormDraftsOf: formName in: app) 
			select: [:each | (each hasUser: username readAccessUsing: definition permissions) 
									or: [each hasRole: group readAccessUsing: definition permissions]]);
		yourself! !

!WAOrbeonPersistenceApiService methodsFor: 'summary' stamp: 'BrunoBB 08/17/2015 13:10'!
getXmlNodeFor: anOrbeon_Form_Definition with: anXMLWriter

	anXMLWriter tag: 'form' with: [
		anXMLWriter tag: 'application-name' with: anOrbeon_Form_Definition app.
		anXMLWriter tag: 'form-name' with: anOrbeon_Form_Definition form.
		anXMLWriter tag: 'title' with: anOrbeon_Form_Definition title.
		anXMLWriter tag: 'description' with: anOrbeon_Form_Definition description.
		anXMLWriter tag: 'last-modified-time' with: anOrbeon_Form_Definition last_modified_time asOrbeonDateTimeString.
		anXMLWriter tag: 'available' with: anOrbeon_Form_Definition available.
	].! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/16/2015 17:19'!
getXmlOfFormDraftWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode ) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| orbeonInstance definition permissions username group |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/draft/{1}/data.xml'>

	definition := Orbeon_Form_Definition getLatestFormDefinition: form app: app.
	orbeonInstance := Orbeon_Form_Data getFormDraft: form in: app withId: id.
	group := self requestContext request headerAt: 'orbeon-group'.
	username := self requestContext request headerAt: 'orbeon-username'.
	permissions := self getPermissionsFor: orbeonInstance user: username group: group in: definition.
	
	self requestContext response headerAt: 'orbeon-operations' put: permissions.

	^((GRCodec forEncoding: 'utf-8') decode: orbeonInstance xml) asString! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/16/2015 17:20'!
getXmlOfFormInstanceWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode ) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| orbeonInstance definition permissions username group |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/data/{1}/data.xml'>

	definition := Orbeon_Form_Definition getLatestFormDefinition: form app: app.
	orbeonInstance := Orbeon_Form_Data getFormInstance: form in: app withId: id.
	group := self requestContext request headerAt: 'orbeon-group'.
	username := self requestContext request headerAt: 'orbeon-username'.
	permissions := self getPermissionsFor: orbeonInstance user: username group: group in: definition.

	self requestContext response headerAt: 'orbeon-operations' put: permissions.

	^((GRCodec forEncoding: 'utf-8') decode: orbeonInstance xml) asString! !

!WAOrbeonPersistenceApiService methodsFor: 'other' stamp: 'BrunoBB 08/05/2015 12:37'!
hardCodeAnswer

	^'<documents xmlns:ev="http://www.w3.org/2001/xml-events" xmlns:f="http//www.orbeon.com/function" xmlns:frf="java:org.orbeon.oxf.fr.FormRunner" xmlns:odt="http://orbeon.org/oxf/xml/datatypes" xmlns:oxf="http://www.orbeon.com/oxf/processors" xmlns:p="http://www.orbeon.com/oxf/pipeline" xmlns:saxon="http://saxon.sf.net/" xmlns:sql="http://orbeon.org/oxf/xml/sql" xmlns:xf="http://www.w3.org/2002/xforms" xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:xpl="java:org.orbeon.oxf.pipeline.api.FunctionLibrary" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xxf="http://orbeon.org/oxf/xml/xforms" search-total="9" total="9">
	<document created="2015-07-15T22:11:24.849Z" draft="N" last-modified="2015-07-21T20:35:59.893Z" name="1526e81d6d405ec1ac1d4849f7cacfa18572220c" operations="*">
		<details>
			<detail>ue</detail>
			<detail>complete-test</detail>
			<detail>Complete Test</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-13T23:44:05.993Z" draft="N" last-modified="2015-06-13T23:45:26.604Z" name="2e387e31fb83fb21d996708dc2c66c5e599ff4a1" operations="*">
		<details>
			<detail>ue</detail>
			<detail>procesar-permiso-general</detail>
			<detail>Procesar Permiso General</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-13T23:41:57.945Z" draft="N" last-modified="2015-06-13T23:46:04.939Z" name="a233448a57a88e4d5d38fe8ad154832a82c96386" operations="*">
		<details>
			<detail>ue</detail>
			<detail>analisis-contruccion</detail>
			<detail>Analisis Construccion</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:56:33.557Z" draft="N" last-modified="2015-06-03T19:01:44.747Z" name="bd1a4d6216254db2c2e46e6612b7c4b2eabaa726" operations="*">
		<details>
			<detail>ue</detail>
			<detail>resultado-permiso</detail>
			<detail>Resultado Permiso Construccion</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:55:23.270Z" draft="N" last-modified="2015-06-03T19:00:57.204Z" name="6bfcdc725198640914adbb169b848c3651f182d9" operations="*">
		<details>
			<detail>ue</detail>
			<detail>analisis-estructura</detail>
			<detail>Analisis Estructura</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:47:33.837Z" draft="N" last-modified="2015-06-03T19:00:17.169Z" name="8aaa73a2b8bfc710b4762e96597c62a2dbcfe7c0" operations="*">
		<details>
			<detail>ue</detail>
			<detail>procesar-permiso-fabrica</detail>
			<detail>Procesar Permiso FABRICA</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:46:42.458Z" draft="N" last-modified="2015-06-03T18:59:40.262Z" name="bddc4e7171bfb0fe6d278f7694d2bb33e0e840a6" operations="*">
		<details>
			<detail>ue</detail>
			<detail>procesar-permiso-edificio</detail>
			<detail>Procesar Permiso Edificio</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:45:45.653Z" draft="N" last-modified="2015-06-03T18:59:02.697Z" name="32f1b9377c2cc04d799aa5e3dd6b9c0ad6a68780" operations="*">
		<details>
			<detail>ue</detail>
			<detail>procesar-permiso-casa</detail>
			<detail>Procesar Permiso Casa</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:44:39.982Z" draft="N" last-modified="2015-06-03T18:57:01.444Z" name="31c81f6274d68dce5f5e14e9efc163f32b2145dd" operations="*">
		<details>
			<detail>ue</detail>
			<detail>peticion-permiso-construccion</detail>
			<detail>Peticion Permiso Construccion</detail>
			<detail/>
		</details>
	</document>
</documents>'! !

!WAOrbeonPersistenceApiService methodsFor: 'other' stamp: 'BrunoBB 08/12/2015 15:07'!
hardCodeAnswer2

	^'<?xml version="1.0" encoding="UTF-8"?><forms><form>
        <application-name>orbeon</application-name>
        <form-name>w9</form-name>
        <title xml:lang="en">Request for Taxpayer Identification Number and Certification</title>
        <description xml:lang="en"/>
        <last-modified-time>2015-05-05T19:12:33.711-04:00</last-modified-time>
    </form><form>
        <application-name>orbeon</application-name>
        <form-name>library</form-name>
        <title xml:lang="en">Global Library</title>
        <description xml:lang="en">This special form contains the global Form Builder library of section templates accessible from all forms.</description>
        <title xml:lang="fr">Bibliothque globale</title>
        <description xml:lang="fr">Ce formulaire spcial contient la bibliothque global de Form Builder, avec les modles de sections disponibles depuis tous les formulaires.</description>
        <logo mediatype="" filename="" size=""/>
        <last-modified-time>2015-05-05T19:12:33.567-04:00</last-modified-time>
    </form><form>
        <application-name>orbeon</application-name>
        <form-name>controls</form-name>
        <title xml:lang="en">Form Builder Controls</title>
        <description xml:lang="en">This form shows all the built-in controls supported by Form Builder</description>
        <title xml:lang="fr">Contrles de Form Builder</title>
        <description xml:lang="fr">Ce formulaire montre tous les contrles supports par Form Builder</description>
        <last-modified-time>2015-05-05T19:12:33.178-04:00</last-modified-time>
    </form><form>
        <application-name>orbeon</application-name>
        <form-name>contact</form-name>
        <title xml:lang="en">Contact</title>
        <description xml:lang="en">The Contact form is a simple form which can be created in a few minutes with Form Builder.</description>
        <title xml:lang="fr">Contact</title>
        <description xml:lang="fr">Le formulaire Contact peut tre cr  laide de Form Builder en quelques minutes.</description>
        <last-modified-time>2015-05-05T19:12:33.011-04:00</last-modified-time>
    </form><form>
        <application-name>orbeon</application-name>
        <form-name>bookshelf</form-name>
        <title xml:lang="en">Orbeon Forms Bookshelf</title>
        <description xml:lang="en">Orbeon Forms Bookshelf is a simple form allowing you to gather information about books.</description>
        <title xml:lang="fr">Orbeon Forms Bookshelf</title>
        <description xml:lang="fr">Orbeon Forms Bookshelf prsente un formulaire simple qui vous permet de saisir des informations sur des livres.</description>
        <migration version="4.8.0">[{ "path": "notes/note", "iteration-name": "note-iteration" }]</migration>
        <last-modified-time>2015-05-05T19:12:29.311-04:00</last-modified-time>
    </form></forms>'! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/18/2015 13:59'!
publishFormDefinition: formName app: app withId: documentId
	"This method is called by Orbeon when a Form Definition has been published with form name <formName> in application <app> with form id <documentId>"
	| orbeonDefinition headerVersion currentVersion |
	<put>
	<consumes: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml?document={3}'>

	orbeonDefinition := Orbeon_Form_Definition new.
	orbeonDefinition parentInstance: (Orbeon_Form_Data getFormDefinition: formName in: app withId: documentId ifNone: [nil]).

	headerVersion := (self requestContext request headerAt: 'orbeon-form-definition-version').
	currentVersion := Orbeon_Form_Definition getLatestFormDefinitionVersion: formName app: app.
	"Orbeon put -next- when a new version is going to be generated if NOT --> the current version is updated"
	(headerVersion = 'next') ifTrue: [currentVersion := currentVersion + 1].

	orbeonDefinition xml: self requestContext request rawBody;
		updateLastModifiedTime;
		form_version: currentVersion;
		setMetadata;
		available: 'true';
		addToStorage.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/24/2015 12:48'!
receiveAndPublishFileFor: formName app: app documentId: documentId fileId: fileId
	"This service is called when a user click -Publish- form in Orbeon Form Builder and the form definition has attached files.
	The Form Definition is <formName> in the Orbeon Application <app> where the id of the form definition is <documentId> and the attached file id is <fileId>.
	This service is called for each attached fiel in the Form Definition. 
	The attached file is stored in the repository"
	| gsFile |
	<put>
	<path: '/crud/{2}/{1}/form/{4}?document={3}'>

	gsFile := GsFile open: ('/opt/orbeon-files/definitions/published/', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/24/2015 12:48'!
receiveAndSaveFileForDefinitionWithId: definitionId fileId: fileId valid: aBoolean
	"This service receives a file with id <fileId> from Orbeon Form Builder when the a user clicked -Save-.
	The file was uploaded into a Form Definition as a Custom PDF or as direct file Upload.
	A direct file upload is when a File Attachment is added to a Form Definition and a concrete file is also uploaded"
	| stream gsFile |
	<put>
	<path: '/crud/orbeon/builder/data/{1}/{2}.bin?valid={3}'>

	gsFile := GsFile open: ('/opt/orbeon-files/definitions/saved/', fileId, '.bin') mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/24/2015 12:48'!
receiveAndSaveFileForDraft: formName app: app definitionId: definitionId fileId: fileId valid: aBoolean
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded (and autosave is -true-) to a Form Instance.
	When the form is autosaved then all form's attachments are sent to this service "
	| stream gsFile |
	<put>
	<path: '/crud/{2}/{1}/draft/{3}/{4}?valid={5}'>

	gsFile := GsFile open: ('/opt/orbeon-files/drafts/', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/24/2015 12:49'!
receiveAndSaveFileForInstance: formName app: app definitionId: definitionId fileId: fileId valid: aBoolean
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded to a Form Instance.
	When the form is sent then all form's attachments are sent to this service"
	| stream gsFile |
	<put>
	<path: '/crud/{2}/{1}/data/{3}/{4}?valid={5}'>

	gsFile := GsFile open: ('/opt/orbeon-files/instances/', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/24/2015 16:40'!
saveDraftFormInstance: formName app: app withId: id valid: aBoolean
	"This method is called by Orbeon when a Form is autosaved in a Form Instance page"
	| orbeonDraft |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/draft/{3}/data.xml?valid={4}'>

	orbeonDraft := Orbeon_Form_Data new. "we preserve the existing form instance so we create a new one"

	orbeonDraft xml: self requestContext request rawBody;
		app: app;
		form: formName;
		draft: 'Y';
		document_id: id;
		form_version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		last_modified_by: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group');
		updateLastModifiedTime;
		addToStorageAsDraft.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/16/2015 12:06'!
saveFinalFormInstance: formName app: app withId: id valid: aBoolean
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| orbeonInstance |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml?valid={4}'>

	orbeonInstance := Orbeon_Form_Data getFormInstance: formName in: app withId: id ifNone: [Orbeon_Form_Data new].

	orbeonInstance xml: self requestContext request rawBody;
		app: app;
		form: formName;
		document_id: id;
		form_version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		last_modified_by: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group');
		updateLastModifiedTime;
		addToStorage.
	"we already saved a final version --> there is NO more draft left in storage. we must remove it"
	orbeonInstance removeFromStorageAsDraft.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/27/2015 18:05'!
saveInFormBuilderDefinitionWithId: id valid: aBoolean
	"This service is called by Orbeon when a user click on -Save- inside the Form Builder.
	A Form Definition has been saved "
	| orbeonData |
	<put>
	<path: '/crud2/orbeon/builder/data/{1}/data.xml/?valid={2}'>

	orbeonData := Orbeon_Form_Data getFormInstanceWithId: id ifNone: [Orbeon_Form_Data new].

	orbeonData xml: self requestContext request rawBody;
		isDefinition: true;
		document_id: id;
		form_version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		updateLastModifiedTime;
		setMetadata;
		addToStorage.! !

!WAOrbeonPersistenceApiService methodsFor: 'service-post' stamp: 'BrunoBB 08/17/2015 15:36'!
searchInFormBuilderSummary
	"This service is called by Orbeon when rendering an Orbeon Form Builder Summary page and
	answer a well formatted XML with the result of the query received in the request.
	This XML is going to be displayed in the Orbeon Form Builder Summary page"	
	| xmlDocument definitions pageSize pageNumber from to |
	<post>
	<produces: 'application/xml'>
	<path: '/search/orbeon/builder'>

	xmlDocument := XMLDOMParser parse: self requestContext request rawBody.
	definitions := self applyQueryToFormDefinition: xmlDocument.
	pageSize := self getPageSizeFrom: xmlDocument.
	pageNumber := self getPageNumberFrom: xmlDocument.
	to := pageSize * pageNumber.
	from := to - pageSize + 1.
	to := (to>= definitions size) ifTrue: [definitions size] ifFalse: [to].

	^self generateXmlAnswerForBuilderSummary: (definitions copyFrom: from to: to)
			searchTotal: definitions size! !

!WAOrbeonPersistenceApiService methodsFor: 'service-post' stamp: 'BrunoBB 08/21/2015 11:04'!
searchInFormSummary: formName app: app
	"This service is called by Orbeon when rendering an Orbeon Form Summary page and
	answer a well formatted XML with the result of the query received in the request.
	This XML is going to be displayed in the Orbeon Form Summary page"
	| xmlDocument queryNodes instances group username definition filteredInstances pageSize pageNumber from to |
	<post>
	<produces: 'application/xml'>
	<path: '/search/{2}/{1}'>

	xmlDocument := XMLDOMParser parse: self requestContext request rawBody.
	queryNodes := self getQueryNodesFrom: xmlDocument.
	group := self requestContext request headerAt: 'orbeon-group'.
	username := self requestContext request headerAt: 'orbeon-username'.
	instances := self getInstancesTypeFrom: xmlDocument for: username inGroup: group forForm: formName in: app.
	definition := Orbeon_Form_Definition getLatestFormDefinition: formName app: app.
	"here apply the filters for that entered in the web application for search purpose (example: id=123456)"
	filteredInstances := self applyQueryToFormInstance: instances queryNodes: queryNodes.

	pageSize := self getPageSizeFrom: xmlDocument.
	pageNumber := self getPageNumberFrom: xmlDocument.
	to := pageSize * pageNumber.
	from := to - pageSize + 1.
	to := (to>= filteredInstances size) ifTrue: [filteredInstances size] ifFalse: [to].

	^self generateXmlAnswerFor: definition
				summary: (filteredInstances copyFrom: from to: to)
				withQueryNodes: queryNodes
				user: username
				group: group
				searchTotal: filteredInstances size! !

!WAOrbeonPersistenceApiService methodsFor: 'other' stamp: 'BrunoBB 08/04/2015 13:28'!
seasideMimeDocument

	^WAMimeDocument on: 'OK' mimeType: WAMimeType textPlain! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/24/2015 13:01'!
sendFileForDefinitionWithId: definitionId fileId: fileId
	"This service is called by Orbeon Form Builder to get/obtain the attached file with id <fileId> for the Form Definition <definitionId>.
	The service answer an octet stream to the caller."
	| contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/orbeon/builder/data/{1}/{2}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ('/opt/orbeon-files/definitions/saved/', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/24/2015 16:44'!
sendFileForDraft: formName app: app definitionId: definitionId fileId: fileId
	"This service is called when rendering the Draft of the form in Form Instance page"
	| contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/draft/{3}/{4}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ('/opt/orbeon-files/drafts/', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/24/2015 16:44'!
sendFileForInstance: formName app: app definitionId: definitionId fileId: fileId
	"This service is called when rendering the form Instance in Form Instance page"
	| contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/data/{3}/{4}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ('/opt/orbeon-files/instances/', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceApiService methodsFor: 'service-get' stamp: 'BrunoBB 08/27/2015 17:40'!
sendFileForInstance: formName app: app fileId: fileId
	"This service is called when Orbeon requires a Custom PDF of a form or the Form Instance has any attachments and the user has clicked -Send-"
	| contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/borrar-esto/crud/{2}/{1}/form/{3}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ('/opt/orbeon-files/definitions/published/', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceApiService methodsFor: 'service-put' stamp: 'BrunoBB 08/20/2015 11:26'!
unpublishFormDefinition: formName app: app
	"This method is called by Orbeon when a Form Definition has been unpublished with form name <formName> in application <app>"
	<put>
	<path: '/crud/{2}/{1}/form/form.xhtml'>

	(Orbeon_Form_Definition getLatestFormDefinition: formName app: app) 
		switchAvailable

"	(Orbeon_Form_Definition getLatestFormDefinition: formName app: app) xml: self requestContext request rawBody"! !

WARestfulHandler subclass: #WAOrbeonPersistenceLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Persistence_API'!

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 15:01'!
addDeferredProcessingFor: anOrbeonFormInstance
	"The receiver add the form instance <anOrbeonFormInstance> to be processed later by other gem"

	OrbeonDeferredProcessingQueue default addDeferredInstance: anOrbeonFormInstance! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 14:01'!
apiConfiguration

	^OrbeonApiConfiguration default! !

!WAOrbeonPersistenceLayer methodsFor: 'queries' stamp: 'BrunoBB 09/11/2015 11:46'!
applyQuery: xmlDocument toFormDefinitions: anOrderedCollection
	"The receiver apply the query contained in xml document <xmlDocument> to the OrbeonFormInstanceDefinition in the collection <anOrderedCollection>"
	| queryNodes queryFields result |

	queryFields := Dictionary new. "dictionary with the criteria to search"
	result := anOrderedCollection select: [:each | each deleted = 'N']. "exclude deleted definitions"

	queryNodes := (xmlDocument allElementsNamed: 'query') do: [:node | "get the criteria from <xmlDocument>"
		node strings notEmpty ifTrue: [queryFields at: (node attributeAt: 'name') put: node strings last]].

	"apply all available criteria to the result collection <result>"
	queryFields keysAndValuesDo: [:key :value |
		(key = 'application-name') ifTrue: [result := result select: [:each | each app = (queryFields at: 'application-name')]].
		(key = 'form-name') ifTrue: [result := result select: [:each | each form = (queryFields at: 'form-name')]].
		(key = 'title') ifTrue: [result := result select: [:each | each title = (queryFields at: 'title')]].
		(key = 'description') ifTrue: [result := result select: [:each | each description = (queryFields at: 'description')]].
	].

	^result! !

!WAOrbeonPersistenceLayer methodsFor: 'queries' stamp: 'BrunoBB 09/11/2015 11:35'!
applyQueryToFormInstance: instances queryNodes: collectionOfOrbeonQueryNode
	"The receiver apply the query contained in the collection <collectionOfOrbeonQueryNode> to collection of forms contained in <instances>"
	| query |

	"select only nodes that are for search purpose and has a value to filter"
	query := collectionOfOrbeonQueryNode select: [:each | each isSearchAndHasValue].

	^(instances select: [:each | each satisfyQuery: query]) asOrderedCollection! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 08/26/2015 17:55'!
createOrbeonApplicationNamed: appName

	^OrbeonApplication new
		app: appName;
		addToCache;
		yourself! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/08/2015 07:21'!
defaultDefinitionAnswer: formName app: app
	"This method is called when the OrbeonApplication was not found. This can be caused by Orbeon calling library forms"

	self requestContext response headerAt: 'orbeon-form-definition-version' put: '1'.

	^(GRCodec forEncoding: 'utf-8') decode: (OrbeonFormDefinition defaultXmlDefinition: formName app: app)! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'BrunoBB 09/02/2015 14:16'!
deleteFormDefinitionWithId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| orbeonInstance |
	<delete>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	OrbeonApplication logicalRemoveDefinitionWithId: id ifNone: [nil]! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'BrunoBB 09/06/2015 16:27'!
deleteFormDraft: formName app: app withId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| application definition instance |
	<delete>
	<path: '/crud/{2}/{1}/draft/{3}/data.xml'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No application named [', app, '] was found'].
	definition := OrbeonApplication formDefinitionNamed: formName in: app.
	instance := definition getDraftWithId: id ifNone: [^self].

	definition removeDraft: instance! !

!WAOrbeonPersistenceLayer methodsFor: 'service-delete' stamp: 'BrunoBB 09/02/2015 14:58'!
deleteFormInstance: formName app: app withId: id
	"This method is called by Orbeon when a user click -Send- in a Form Instance page"
	| application definition instance |
	<delete>
	<path: '/crud/{2}/{1}/data/{3}/data.xml'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No application named [', app, '] was found'].
	definition := OrbeonApplication formDefinitionNamed: formName in: app.
	instance := definition getInstanceWithId: id ifNone: [^self].

	instance logicalDelete! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/11/2015 12:53'!
duplicateFormDefinitionNewId: id
	"This service duplicate the <OrbeonFormDefinitionInstance> contained in the request body with the new id <id>"
	| application instanceDefinition currentDefinition |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	instanceDefinition := OrbeonFormInstanceDefinition new.

	instanceDefinition xmlString: self requestContext request rawBody;
		id: id;
		setApplicationAndFormName;
		version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		updateLastModifiedTime.

	application := OrbeonApplication 
							applicationNamed: instanceDefinition app
							ifNone: [^NoOrbeonAppException signal: 'No such application [', instanceDefinition app, ']'].

	currentDefinition := application getLatestSavedDefinition: instanceDefinition form.
	instanceDefinition setXmlString: instanceDefinition xmlString; "create the associated OrbeonFormDefinition"
		title: currentDefinition title;
		description: currentDefinition description.

	application addSavedDefinition: instanceDefinition! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/02/2015 15:03'!
duplicateFormInstance: formName app: app newId: id
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| orbeonInstance |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml'>

	orbeonInstance := OrbeonFormInstance new.

	orbeonInstance xml: self requestContext request rawBody;
		app: app;
		form: formName;
		id: id;
		version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		updateLastModifiedTime.! !

!WAOrbeonPersistenceLayer methodsFor: 'xml op' stamp: 'BrunoBB 09/18/2015 08:12'!
generateXmlAnswerFor: formDefinition summary: instanceCollection withQueryNodes: collectionOfOrbeonQueryNode user: username group: group repositoryTotal: repositoryTotal searchTotal: searchTotal
	"The receiver generate a XML string for each element in <instanceCollection> where the values to show are the summary fields contained in <collectionOfOrbeonQueryNode>.
	The form definition <formDefinition> the username <username> and the group <group> are used to get the permissions of the current user over the forms"
	| xmlWriter summaryFields |

	xmlWriter := XMLWriter new.
	summaryFields := collectionOfOrbeonQueryNode select: [:each | each isSummary] thenCollect: [:each | each name]. "get the summary fields"

	xmlWriter writeWith: [:writer | | tag |
		tag := writer tag: 'documents' attributes: (self getArrayOfOrbeonHeadersTotal: repositoryTotal searchTotal: searchTotal). "create the header of the XML"
		"generate a XML node for each form in <instanceCollection>"
		tag with: [instanceCollection do: [:each | self generateXmlNodeFor: each definition: formDefinition summary: summaryFields with: writer user: username group: group]].
	].

	 ^xmlWriter contents! !

!WAOrbeonPersistenceLayer methodsFor: 'xml op' stamp: 'BrunoBB 09/11/2015 12:16'!
generateXmlAnswerForBuilderSummary: definitionCollection searchTotal: searchTotal
	"The receiver generate a XML string for the <anOrbeonFormInstanceDefinition> in collection <definitionCollection> where total of instance is <searchTotal>.
	<definitionCollection> is filtered collection so definitionCollection size ~= searchTotal"
	| xmlWriter |

	xmlWriter := XMLWriter new.

	xmlWriter writeWith: [:writer | | tag |
		tag := writer tag: 'documents' attributes: (self getArrayOfOrbeonHeadersFor: definitionCollection searchTotal: searchTotal). "create the header of the XML"
		"generate XML nodes for each element in <definitionCollection>"
		tag with: [definitionCollection do: [:each | self generateXmlNodeForDefinition: each with: writer]].
	].

	 ^xmlWriter contents! !

!WAOrbeonPersistenceLayer methodsFor: 'xml op' stamp: 'BrunoBB 09/11/2015 12:10'!
generateXmlNodeFor: anOrbeonFormInstance definition: formDefinition summary: collectionOfNames with: aXMLWriter user: username group: group
	"The receiver generate XML nodes for summary fields of form <anOrbeonFormInstance> with form definition <formDefinition>.
	The summary fields to show are in <collectionOfNames>.
	The form definition <formDefinition> the username and <username> the group <group> are used to get the permissions"
	| nodeAttributes tag |

	nodeAttributes := OrderedCollection new
		add: 'created' -> anOrbeonFormInstance createdTime asOrbeonDateTimeString;
		add: 'draft' -> anOrbeonFormInstance printDraft;
		add: 'last-modified' -> anOrbeonFormInstance modifiedTime asOrbeonDateTimeString;
		add: 'name' -> anOrbeonFormInstance id;
		add: 'operations' -> (self getPermissionsFor: anOrbeonFormInstance user: username group: group in: formDefinition);
		asArray.

	tag := aXMLWriter tag: 'document' attributes: nodeAttributes.

	tag with: [aXMLWriter 
						tag: 'details' 
						with: [(anOrbeonFormInstance getValueOfFields: collectionOfNames) "get the values of fields to display in the summary"
									do: [:each | aXMLWriter tag: 'detail' with: each]]].! !

!WAOrbeonPersistenceLayer methodsFor: 'xml op' stamp: 'BrunoBB 09/11/2015 12:18'!
generateXmlNodeForDefinition: anOrbeonFormInstanceDefinition with: aXMLWriter
	"The receiver generate a XML structure for the definition <anOrbeonFormInstanceDefinition>.
	Defaults fields to show (createdTime, draft, modifiedTime, app, form, title, description).
	This is method is for Form Builder Summary"
	| nodeAttributes tag |

	nodeAttributes := OrderedCollection new
		add: 'created' -> anOrbeonFormInstanceDefinition createdTime asOrbeonDateTimeString;
		add: 'draft' -> anOrbeonFormInstanceDefinition printDraft;
		add: 'last-modified' -> anOrbeonFormInstanceDefinition modifiedTime asOrbeonDateTimeString;
		add: 'name' -> anOrbeonFormInstanceDefinition id;
		add: 'operations' -> '*';
		asArray.

	tag := aXMLWriter tag: 'document' attributes: nodeAttributes.

	tag with: [aXMLWriter tag: 'details' 
									with: [aXMLWriter tag: 'detail' with: anOrbeonFormInstanceDefinition app.
											aXMLWriter tag: 'detail' with: anOrbeonFormInstanceDefinition form.
											aXMLWriter tag: 'detail' with: anOrbeonFormInstanceDefinition title.
											aXMLWriter tag: 'detail' with: anOrbeonFormInstanceDefinition description.]]! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 12:57'!
getApplicationNameFrom: xmlDocument ifNone: aBlock
	"The receiver get the application name from the xml document <xmlDocument> if none is found evaluate the zero argument block <aBlock>"

	^(xmlDocument findElementNamed: 'application-name')
		ifNotNil: [:value | value strings isEmpty ifTrue: aBlock ifFalse: [value strings last]]
		ifNil: aBlock.! !

!WAOrbeonPersistenceLayer methodsFor: 'summary' stamp: 'BrunoBB 09/18/2015 07:33'!
getArrayOfOrbeonHeadersFor: anOrderedCollection searchTotal: searchTotal
	"The receiver creates a collection with the header of the XML to show in the Summary page"
	^OrderedCollection new
		add: 'xmlns:ev' -> 'http://www.w3.org/2001/xml-events';
		add: 'xmlns:f' -> 'http//www.orbeon.com/function';
		add: 'xmlns:frf' -> 'java:org.orbeon.oxf.fr.FormRunner';
		add: 'xmlns:odt' -> 'http://orbeon.org/oxf/xml/datatypes';
		add: 'xmlns:oxf' -> 'http://www.orbeon.com/oxf/processors';
		add: 'xmlns:p' -> 'http://www.orbeon.com/oxf/pipeline';
		add: 'xmlns:saxon' -> 'http://saxon.sf.net/';
		add: 'xmlns:sql' -> 'http://orbeon.org/oxf/xml/sql';
		add: 'xmlns:xf' -> 'http://www.w3.org/2002/xforms';
		add: 'xmlns:xi' -> 'http://www.w3.org/2001/XInclude';
		add: 'xmlns:xpl' -> 'java:org.orbeon.oxf.pipeline.api.FunctionLibrary';
		add: 'xmlns:xs' -> 'http://www.w3.org/2001/XMLSchema';
		add: 'xmlns:xxf' -> 'http://orbeon.org/oxf/xml/xforms';
		add: 'page-size' -> '10';
		add: 'total' -> searchTotal printString;
		add: 'search-total' -> (anOrderedCollection size printString);
		asArray! !

!WAOrbeonPersistenceLayer methodsFor: 'summary' stamp: 'BrunoBB 09/18/2015 09:52'!
getArrayOfOrbeonHeadersTotal: total searchTotal: searchTotal
	"The receiver creates a collection with the header of the XML to show in the Summary page"

	^OrderedCollection new
		add: 'xmlns:ev' -> 'http://www.w3.org/2001/xml-events';
		add: 'xmlns:f' -> 'http//www.orbeon.com/function';
		add: 'xmlns:frf' -> 'java:org.orbeon.oxf.fr.FormRunner';
		add: 'xmlns:odt' -> 'http://orbeon.org/oxf/xml/datatypes';
		add: 'xmlns:oxf' -> 'http://www.orbeon.com/oxf/processors';
		add: 'xmlns:p' -> 'http://www.orbeon.com/oxf/pipeline';
		add: 'xmlns:saxon' -> 'http://saxon.sf.net/';
		add: 'xmlns:sql' -> 'http://orbeon.org/oxf/xml/sql';
		add: 'xmlns:xf' -> 'http://www.w3.org/2002/xforms';
		add: 'xmlns:xi' -> 'http://www.w3.org/2001/XInclude';
		add: 'xmlns:xpl' -> 'java:org.orbeon.oxf.pipeline.api.FunctionLibrary';
		add: 'xmlns:xs' -> 'http://www.w3.org/2001/XMLSchema';
		add: 'xmlns:xxf' -> 'http://orbeon.org/oxf/xml/xforms';
		add: 'page-size' -> '10';
		add: 'total' ->  total printString;
		add: 'search-total' -> searchTotal printString;
		asArray! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/09/2015 15:12'!
getDefinitionForFormInstanceWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page (or go directly to edit/view page of a form). The Summary then open the Form Instance in it's corresponding form definition.
	This service is used in combination of #getXmlOfFormInstanceWithId:form:app: to <get> the actual data of the form"
	| application orbeonDefinition latestVersionNumber |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/form/form.xhtml?document={1}'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No application named [', app, '] was found'].
	latestVersionNumber := application getLastFormDefinitionVersionOf: form.
	orbeonDefinition := application definitionNamed: form.

	self requestContext response headerAt: 'orbeon-form-definition-version' put: latestVersionNumber printString.

	^((GRCodec forEncoding: 'utf-8') decode: orbeonDefinition xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/09/2015 14:38'!
getFormDefinitionWithId: id 
	"This service is called when a click is performed on the Orbeon Form Builder Summary page.
	The Summary then should open the Orbeon Builder with the code of the clicked form."
	| orbeonData |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/orbeon/builder/data/{1}/data.xml'>

	^((GRCodec forEncoding: 'utf-8') 
		decode: (OrbeonApplication getSavedDefinitionWithId: id ifNone: [^NoOrbeonFormException signal]) xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 12:58'!
getFormDescriptionFrom: xmlDocument ifNone: aBlock
	"The receiver get the form description from the xml document <xmlDocument> if none is found evaluate the zero argument block <aBlock>"

	^(xmlDocument findElementNamed: 'description')
		ifNotNil: [:value | value strings isEmpty ifTrue: aBlock ifFalse: [value strings last]]
		ifNil: aBlock.! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 12:58'!
getFormNameFrom: xmlDocument ifNone: aBlock
	"The receiver get the form name from the xml document <xmlDocument> if none is found evaluate the zero argument block <aBlock>"

	^(xmlDocument findElementNamed: 'form-name')
		ifNotNil: [:value | value strings isEmpty ifTrue: aBlock ifFalse: [value strings last]]
		ifNil: aBlock.! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 12:59'!
getFormTitleFrom: xmlDocument ifNone: aBlock
	"The receiver get the form title from the xml document <xmlDocument> if none is found evaluate the zero argument block <aBlock>"

	^(xmlDocument findElementNamed: 'title')
		ifNotNil: [:value | value strings isEmpty ifTrue: aBlock ifFalse: [value strings last]]
		ifNil: aBlock.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/09/2015 14:40'!
getFormVersion: formName app: app 
	"This method is called by Orbeon when a Form Definition (inside the Builder) is about to be Published.
	This method answer the latest version of the form definition <formName> in application <app>.
	Using the header <orbeon-form-definition-version> to set the version number.
	It also called when a new Form Instance page is about to be displayed (app/form/new)"
	| application latestVersionNumber |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml'>

	application := OrbeonApplication applicationNamed: app ifNone: [^self defaultDefinitionAnswer: formName app: app].
	latestVersionNumber := application getLastFormDefinitionVersionOf: formName.

	self requestContext response headerAt: 'orbeon-form-definition-version' put: latestVersionNumber printString.

	^((GRCodec forEncoding: 'utf-8') decode: (application getLatestSavedDefinition: formName) xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/01/2015 17:46'!
getOrbeonFr
	"This service is called when accessing Form Runner Home: ../orbeon/fr/ "
	| xmlWriter |
	<get>
	<produces: 'application/xml'>
	<path: '/form'>

	xmlWriter := XMLWriter new.
	xmlWriter writeWith: [:writer | | tag | 
		writer tag: 'forms' with: [OrbeonApplication getLastDefinitions do: [:eachDef | 
			self getXmlNodeFor: eachDef with: writer]].
	].

	^xmlWriter contents! !

!WAOrbeonPersistenceLayer methodsFor: 'summary' stamp: 'BrunoBB 09/11/2015 12:49'!
getPermissionsFor: anOrbeonFormInstance user: username group: group in: formDefinition
	"The receiver answer a collection of permissions (a string separated by blanks) in the form <anOrbeonFormInstance> for the user <username> and group <group> using the form definition <formDefinition> to get the current permissions to apply.
	To calculate permissions we use the last version of OrbeonFormDefinition and NOT the <formInstance definition>.
	If not --> is not possible to change permission of a given instance if the definition version is higher that the instance version.
	Using the last version of OrbeonFormDefinition to calculate permissions --> all instance are affected by the change"
	| printStream |

	printStream := PrintStream on: String new.

	((anOrbeonFormInstance hasUser: username createAccessUsing: formDefinition permissions) 
	or: [anOrbeonFormInstance hasRole: group createAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'create '].

	((anOrbeonFormInstance hasUser: username readAccessUsing: formDefinition permissions) 
	or: [anOrbeonFormInstance hasRole: group readAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'read '].

	((anOrbeonFormInstance hasUser: username updateAccessUsing: formDefinition permissions) 
	or: [anOrbeonFormInstance hasRole: group updateAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'update '].

	((anOrbeonFormInstance hasUser: username deleteAccessUsing: formDefinition permissions) 
	or: [anOrbeonFormInstance hasRole: group deleteAccessUsing: formDefinition permissions])
		ifTrue: [printStream nextPutAll: 'delete '].

	^printStream contents! !

!WAOrbeonPersistenceLayer methodsFor: 'xml op' stamp: 'BrunoBB 09/11/2015 12:50'!
getXmlNodeFor: anOrbeonFormDefinition with: anXMLWriter
	"The receiver create a XML structure to display the definition <anOrbeonFormDefinition> in ../orbeon/fr page"

	anXMLWriter tag: 'form' with: [
		anXMLWriter tag: 'application-name' with: anOrbeonFormDefinition app.
		anXMLWriter tag: 'form-name' with: anOrbeonFormDefinition form.
		anXMLWriter tag: 'title' with: anOrbeonFormDefinition title.
		anXMLWriter tag: 'description' with: anOrbeonFormDefinition description.
		anXMLWriter tag: 'last-modified-time' with: anOrbeonFormDefinition modifiedTime asOrbeonDateTimeString.
		anXMLWriter tag: 'available' with: anOrbeonFormDefinition available.
	].! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/09/2015 14:38'!
getXmlOfFormDraftWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode ) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| application definition instance permissions username group |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/draft/{1}/data.xml'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No application named [', app, '] was found'].
	definition := OrbeonApplication formDefinitionNamed: form in: app.
	instance := definition getDraftWithId: id.

	group := self requestContext request headerAt: 'orbeon-group'.
	username := self requestContext request headerAt: 'orbeon-username'.
	permissions := self getPermissionsFor: instance user: username group: group in: definition.
	
	self requestContext response headerAt: 'orbeon-operations' put: permissions.

	^((GRCodec forEncoding: 'utf-8') decode: instance xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/09/2015 14:38'!
getXmlOfFormInstanceWithId: id form: form app: app
	"This service is called when a click is performed on the Orbeon Form Summary page.
	The Summary then should open the Form Instance (view/edit mode ) in the corresponding form definition (template).
	This sevice is used in combination with #getDefinitionForFormInstanceWithId:form:app: that <get> the form definition (template) to the form with id <id>"
	| application orbeonInstance definition permissions username group |
	<get>
	<produces: 'application/xml'>
	<path: '/crud/{3}/{2}/data/{1}/data.xml'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No application named [', app, '] was found'].
	definition := OrbeonApplication formDefinitionNamed: form in: app.
	orbeonInstance := definition getInstanceWithId: id.

	group := self requestContext request headerAt: 'orbeon-group'.
	username := self requestContext request headerAt: 'orbeon-username'.
	permissions := self getPermissionsFor: orbeonInstance user: username group: group in: definition.

	self requestContext response headerAt: 'orbeon-operations' put: permissions.

	^((GRCodec forEncoding: 'utf-8') decode: orbeonInstance xmlString) asString! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 08/25/2015 16:02'!
hardCodeAnswer

	^'<documents xmlns:ev="http://www.w3.org/2001/xml-events" xmlns:f="http//www.orbeon.com/function" xmlns:frf="java:org.orbeon.oxf.fr.FormRunner" xmlns:odt="http://orbeon.org/oxf/xml/datatypes" xmlns:oxf="http://www.orbeon.com/oxf/processors" xmlns:p="http://www.orbeon.com/oxf/pipeline" xmlns:saxon="http://saxon.sf.net/" xmlns:sql="http://orbeon.org/oxf/xml/sql" xmlns:xf="http://www.w3.org/2002/xforms" xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:xpl="java:org.orbeon.oxf.pipeline.api.FunctionLibrary" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xxf="http://orbeon.org/oxf/xml/xforms" search-total="9" total="9">
	<document created="2015-07-15T22:11:24.849Z" draft="N" last-modified="2015-07-21T20:35:59.893Z" name="1526e81d6d405ec1ac1d4849f7cacfa18572220c" operations="*">
		<details>
			<detail>ue</detail>
			<detail>complete-test</detail>
			<detail>Complete Test</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-13T23:44:05.993Z" draft="N" last-modified="2015-06-13T23:45:26.604Z" name="2e387e31fb83fb21d996708dc2c66c5e599ff4a1" operations="*">
		<details>
			<detail>ue</detail>
			<detail>procesar-permiso-general</detail>
			<detail>Procesar Permiso General</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-13T23:41:57.945Z" draft="N" last-modified="2015-06-13T23:46:04.939Z" name="a233448a57a88e4d5d38fe8ad154832a82c96386" operations="*">
		<details>
			<detail>ue</detail>
			<detail>analisis-contruccion</detail>
			<detail>Analisis Construccion</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:56:33.557Z" draft="N" last-modified="2015-06-03T19:01:44.747Z" name="bd1a4d6216254db2c2e46e6612b7c4b2eabaa726" operations="*">
		<details>
			<detail>ue</detail>
			<detail>resultado-permiso</detail>
			<detail>Resultado Permiso Construccion</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:55:23.270Z" draft="N" last-modified="2015-06-03T19:00:57.204Z" name="6bfcdc725198640914adbb169b848c3651f182d9" operations="*">
		<details>
			<detail>ue</detail>
			<detail>analisis-estructura</detail>
			<detail>Analisis Estructura</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:47:33.837Z" draft="N" last-modified="2015-06-03T19:00:17.169Z" name="8aaa73a2b8bfc710b4762e96597c62a2dbcfe7c0" operations="*">
		<details>
			<detail>ue</detail>
			<detail>procesar-permiso-fabrica</detail>
			<detail>Procesar Permiso FABRICA</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:46:42.458Z" draft="N" last-modified="2015-06-03T18:59:40.262Z" name="bddc4e7171bfb0fe6d278f7694d2bb33e0e840a6" operations="*">
		<details>
			<detail>ue</detail>
			<detail>procesar-permiso-edificio</detail>
			<detail>Procesar Permiso Edificio</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:45:45.653Z" draft="N" last-modified="2015-06-03T18:59:02.697Z" name="32f1b9377c2cc04d799aa5e3dd6b9c0ad6a68780" operations="*">
		<details>
			<detail>ue</detail>
			<detail>procesar-permiso-casa</detail>
			<detail>Procesar Permiso Casa</detail>
			<detail/>
		</details>
	</document>
	<document created="2015-06-03T13:44:39.982Z" draft="N" last-modified="2015-06-03T18:57:01.444Z" name="31c81f6274d68dce5f5e14e9efc163f32b2145dd" operations="*">
		<details>
			<detail>ue</detail>
			<detail>peticion-permiso-construccion</detail>
			<detail>Peticion Permiso Construccion</detail>
			<detail/>
		</details>
	</document>
</documents>'! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 08/25/2015 16:02'!
hardCodeAnswer2

	^'<?xml version="1.0" encoding="UTF-8"?><forms><form>
        <application-name>orbeon</application-name>
        <form-name>w9</form-name>
        <title xml:lang="en">Request for Taxpayer Identification Number and Certification</title>
        <description xml:lang="en"/>
        <last-modified-time>2015-05-05T19:12:33.711-04:00</last-modified-time>
    </form><form>
        <application-name>orbeon</application-name>
        <form-name>library</form-name>
        <title xml:lang="en">Global Library</title>
        <description xml:lang="en">This special form contains the global Form Builder library of section templates accessible from all forms.</description>
        <title xml:lang="fr">Bibliothque globale</title>
        <description xml:lang="fr">Ce formulaire spcial contient la bibliothque global de Form Builder, avec les modles de sections disponibles depuis tous les formulaires.</description>
        <logo mediatype="" filename="" size=""/>
        <last-modified-time>2015-05-05T19:12:33.567-04:00</last-modified-time>
    </form><form>
        <application-name>orbeon</application-name>
        <form-name>controls</form-name>
        <title xml:lang="en">Form Builder Controls</title>
        <description xml:lang="en">This form shows all the built-in controls supported by Form Builder</description>
        <title xml:lang="fr">Contrles de Form Builder</title>
        <description xml:lang="fr">Ce formulaire montre tous les contrles supports par Form Builder</description>
        <last-modified-time>2015-05-05T19:12:33.178-04:00</last-modified-time>
    </form><form>
        <application-name>orbeon</application-name>
        <form-name>contact</form-name>
        <title xml:lang="en">Contact</title>
        <description xml:lang="en">The Contact form is a simple form which can be created in a few minutes with Form Builder.</description>
        <title xml:lang="fr">Contact</title>
        <description xml:lang="fr">Le formulaire Contact peut tre cr  laide de Form Builder en quelques minutes.</description>
        <last-modified-time>2015-05-05T19:12:33.011-04:00</last-modified-time>
    </form><form>
        <application-name>orbeon</application-name>
        <form-name>bookshelf</form-name>
        <title xml:lang="en">Orbeon Forms Bookshelf</title>
        <description xml:lang="en">Orbeon Forms Bookshelf is a simple form allowing you to gather information about books.</description>
        <title xml:lang="fr">Orbeon Forms Bookshelf</title>
        <description xml:lang="fr">Orbeon Forms Bookshelf prsente un formulaire simple qui vous permet de saisir des informations sur des livres.</description>
        <migration version="4.8.0">[{ "path": "notes/note", "iteration-name": "note-iteration" }]</migration>
        <last-modified-time>2015-05-05T19:12:29.311-04:00</last-modified-time>
    </form></forms>'! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/08/2015 14:38'!
moveFromTempPathFileOf: anOrbeonFormDefinition
	"The receiver move all files from temp path to the actual path of <anOrbeonFormDefinition>"
	| filesToMove defaultFilePath |

	filesToMove := (((GsFile contentsOfDirectory: self apiConfiguration getTempPath onClient: false) "get all current files in <path>"
			reject: [:eachPathFile | ((eachPathFile subStrings: '/') last = '.') or: [(eachPathFile subStrings: '/') last = '..']])
			collect: [:each | (each subStrings: '/') last])
			select: [:fileName | fileName includesSubstring: anOrbeonFormDefinition id].

	filesToMove isEmpty ifTrue: [^self]. "no files to move"

	defaultFilePath := self apiConfiguration getSavedDefinitionsPathFor: anOrbeonFormDefinition form in: anOrbeonFormDefinition app.

	filesToMove do: [:fileName | | cmd |
		cmd := 'mv ',self apiConfiguration getTempPath, '/', fileName, ' ', defaultFilePath.
		System performOnServer: cmd]! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/11/2015 15:05'!
publishFormDefinition: formName app: app withId: documentId
	"This method is called by Orbeon when a Form Definition has been published with form name <formName> in application <app> with form id <documentId>"
	| orbeonApplication orbeonInstanceDefinition orbeonDefinition headerVersion currentVersion |
	<put>
	<consumes: 'application/xml'>
	<path: '/crud/{2}/{1}/form/form.xhtml?document={3}'>

	orbeonInstanceDefinition := OrbeonApplication getSavedDefinition: formName app: app withId: documentId.
	orbeonDefinition := orbeonInstanceDefinition definition.
	orbeonApplication := orbeonInstanceDefinition getApplication.

	headerVersion := (self requestContext request headerAt: 'orbeon-form-definition-version').
	currentVersion := orbeonApplication getLastFormDefinitionVersionOf: formName.
	"Orbeon put -next- when a new version is going to be generated if NOT --> the current version is updated"
	(headerVersion = 'next') ifTrue: [currentVersion := currentVersion + 1].

	orbeonDefinition 
		updateLastModifiedTime;
		version: currentVersion;
		xmlString: self requestContext request rawBody;
		publish;
		processXMLDefinition. 

	orbeonApplication addPublishedDefinition: orbeonDefinition! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/06/2015 14:28'!
receiveAndPublishFileFor: formName app: app documentId: documentId fileId: fileId
	"This service is called when a user click -Publish- form in Orbeon Form Builder and the form definition has attached files.
	The Form Definition is <formName> in the Orbeon Application <app> where the id of the form definition is <documentId> and the attached file id is <fileId>.
	This service is called for each attached files in the Form Definition. 
	The attached file is stored in the repository"
	| gsFile |
	<put>
	<path: '/crud/{2}/{1}/form/{4}?document={3}'>

	gsFile := GsFile open: ((self apiConfiguration getPublishedDefinitionsPathFor: formName in: app), documentId, '-',fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/08/2015 13:30'!
receiveAndSaveFileForDefinitionWithId: definitionId fileId: fileId valid: aBoolean
	"This service receives a file with id <fileId> from Orbeon Form Builder when the a user clicked -Save-.
	The file was uploaded into a Form Definition as a Custom PDF or as direct file Upload.
	A direct file upload is when a File Attachment is added to a Form Definition and a concrete file is also uploaded"
	| definition stream gsFile |
	<put>
	<path: '/crud/orbeon/builder/data/{1}/{2}.bin?valid={3}'>

	definition := OrbeonApplication getAnyDefinitionWithId: definitionId ifNone: [^self storeFileOnTempPath: fileId definitionId: definitionId].

	gsFile := GsFile open: ((self apiConfiguration getSavedDefinitionsPathFor: definition form in: definition app), definitionId, '-', fileId, '.bin') mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/06/2015 14:29'!
receiveAndSaveFileForDraft: formName app: app definitionId: definitionId fileId: fileId valid: aBoolean
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded (and autosave is -true-) to a Form Instance.
	When the form is autosaved then all form's attachments are sent to this service "
	| stream gsFile |
	<put>
	<path: '/crud/{2}/{1}/draft/{3}/{4}?valid={5}'>

	gsFile := GsFile open: ((self apiConfiguration getDraftsPathFor: formName in: app), definitionId, '-', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/06/2015 14:29'!
receiveAndSaveFileForInstance: formName app: app definitionId: definitionId fileId: fileId valid: aBoolean
	"This service is called from Orbeon Form Runner -new/edit- when a file is uploaded to a Form Instance.
	When the form is sent then all form's attachments are sent to this service"
	| stream gsFile |
	<put>
	<path: '/crud/{2}/{1}/data/{3}/{4}?valid={5}'>

	gsFile := GsFile open: ((self apiConfiguration getInstancesPathFor: formName in: app), definitionId, '-', fileId) mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/16/2015 13:32'!
saveDraftFormInstance: formName app: app withId: id valid: aBoolean
	"This method is called by Orbeon when a Form is autosaved in a Form Instance page"
	| application definition orbeonDraft |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/draft/{3}/data.xml?valid={4}'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No such application [', app, ']'].
	definition := application definitionNamed: formName ifNone: [^NoOrbeonFormException signal: 'No such form [', formName, '] in application [', app, ']'].
	orbeonDraft := definition getDraftWithId: id ifNone: [definition addDraft: (OrbeonFormInstance app: app form: formName id: id)].

	orbeonDraft xmlString: self requestContext request rawBody;
		definition: definition;
		draft: 'Y';
		version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		modifiedUser: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group');
		updateLastModifiedTime;
		processXMLSections. "create the sections and fields but NOT the FormFieldValues"! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/11/2015 15:08'!
saveFinalFormInstance: formName app: app withId: id valid: aBoolean
	"This method is called by Orbeon when a user click 'Send' in a Form Instance page"
	| application definition instance |
	<put>
	<produces: 'application/xml'>
	<path: '/crud/{2}/{1}/data/{3}/data.xml?valid={4}'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No such application [', app, ']'].
	definition := application definitionNamed: formName ifNone: [^NoOrbeonFormException signal: 'No such form [', formName, '] in application [', app, ']'].
	instance := definition 
				getInstanceWithId: id 
				ifNone: [definition getDraftWithId: id ifNone: [OrbeonFormInstance app: app form: formName id: id]].

	instance xmlString: self requestContext request rawBody;
		draft: 'N';
		definition: definition;
		version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		username:  (self requestContext request headerAt: 'orbeon-username'); "BUG - creator set only one time"
		modifiedUser: (self requestContext request headerAt: 'orbeon-username');
		groupname: (self requestContext request headerAt: 'orbeon-group');
		isValid: aBoolean;
		updateLastModifiedTime.

	(self apiConfiguration isDeferredProcessing: formName in: app) 
	ifTrue: [self addDeferredProcessingFor: instance] 
	ifFalse: [instance processXML].

	definition removeDraft: instance. "this is the final version so we remove the current draft if any"! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/11/2015 15:02'!
saveInFormBuilderDefinitionWithId: id valid: aBoolean
	"This service is called by Orbeon when a user click on -Save- inside the Form Builder.
	A Form Definition has been saved "
	| orbeonData xml xmlDocument orbeonApplication savedDefinition appName formName |
	<put>
	<path: '/crud/orbeon/builder/data/{1}/data.xml/?valid={2}'>

	xml := self requestContext request rawBody.
	xmlDocument := XMLDOMParser parse: xml.
	appName := self getApplicationNameFrom: xmlDocument ifNone: [nil].
	formName := self getFormNameFrom: xmlDocument ifNone: [nil].
	orbeonApplication := OrbeonApplication applicationNamed: appName ifNone: [self createOrbeonApplicationNamed: appName].
	savedDefinition := orbeonApplication getSavedDefinitionFor: formName withId: id 
														ifNone: [OrbeonFormInstanceDefinition new app: appName; form: formName; yourself].
	savedDefinition id: id;
		version: (self requestContext request headerAt: 'orbeon-form-definition-version');
		title: (self getFormTitleFrom: xmlDocument ifNone: ['']);
		description: (self getFormDescriptionFrom: xmlDocument ifNone: ['']);
		setXmlString: xml;
		updateLastModifiedTime;
		processXMLDefinition;
		yourself.
	orbeonApplication addSavedDefinition: savedDefinition.
	self moveFromTempPathFileOf: savedDefinition. "move attachments if it is the case -issue #37-"! !

!WAOrbeonPersistenceLayer methodsFor: 'service-post' stamp: 'BrunoBB 09/09/2015 14:10'!
searchInFormBuilderSummary
	"This service is called by Orbeon when rendering an Orbeon Form Builder Summary page and
	answer a well formatted XML with the result of the query received in the request.
	This XML is going to be displayed in the Orbeon Form Builder Summary page"	
	| xmlDocument definitions pageSize pageNumber from to allDefinitions |
	<post>
	<produces: 'application/xml'>
	<path: '/search/orbeon/builder'>

	xmlDocument := XMLDOMParser parse: self requestContext request rawBody.
	allDefinitions := OrbeonApplication getAllSavedDefinitions.
	definitions := self applyQuery: xmlDocument toFormDefinitions: allDefinitions.
	pageSize := self getPageSizeFrom: xmlDocument.
	pageNumber := self getPageNumberFrom: xmlDocument.
	to := pageSize * pageNumber.
	from := to - pageSize + 1.
	to := (to>= definitions size) ifTrue: [definitions size] ifFalse: [to].

	^self generateXmlAnswerForBuilderSummary: (definitions copyFrom: from to: to)
			searchTotal: allDefinitions size! !

!WAOrbeonPersistenceLayer methodsFor: 'service-post' stamp: 'BrunoBB 09/18/2015 10:48'!
searchInFormSummary: formName app: app
	"This service is called by Orbeon when rendering an Orbeon Form Summary page and
	answer a well formatted XML with the result of the query received in the request.
	This XML is going to be displayed in the Orbeon Form Summary page"
	| application definition xmlDocument queryNodes searchApi |
	<post>
	<produces: 'application/xml'>
	<path: '/search/{2}/{1}'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No such application [', app, ']'].
	definition := application definitionNamed: formName ifNone: [^NoOrbeonFormException signal: 'No such form [', formName, '] in application [', app,']'].
	searchApi := OrbeonSearchApi form: definition.
	searchApi xmlSearchDefinitionDocument: (XMLDOMParser parse: self requestContext request rawBody);
					createQueryNodes;
					getPageSize;
					getPageNumber;
					group: (self requestContext request headerAt: 'orbeon-group');
					user: (self requestContext request headerAt: 'orbeon-username').

	searchApi executeQuery.

	^self generateXmlAnswerFor: searchApi formDefinition
				summary: searchApi resultCollection
				withQueryNodes: searchApi queryNodes
				user: searchApi user
				group: searchApi group
				repositoryTotal: searchApi total
				searchTotal: searchApi total! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 08/25/2015 16:02'!
seasideMimeDocument

	^WAMimeDocument on: 'OK' mimeType: WAMimeType textPlain! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/06/2015 14:29'!
sendFileForDefinitionWithId: definitionId fileId: fileId
	"This service is called by Orbeon Form Builder to get/obtain the attached file with id <fileId> for the Form Definition <definitionId>.
	The service answer an octet stream to the caller."
	| definition contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/orbeon/builder/data/{1}/{2}'>

	definition := OrbeonApplication getAnyDefinitionWithId: definitionId ifNone: [^NoOrbeonFormException signal: 'No form definition with id [', definitionId, ']'].

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getSavedDefinitionsPathFor: definition form in: definition app), definitionId, '-',fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/06/2015 14:29'!
sendFileForDraft: formName app: app definitionId: definitionId fileId: fileId
	"This service is called when rendering the Draft of the form in Form Instance page"
	| contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/draft/{3}/{4}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getDraftsPathFor: formName in: app), definitionId, '-', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/06/2015 15:20'!
sendFileForInstance: formName app: app definitionId: definitionId fileId: fileId
	"This service is called when rendering the form Instance in Form Instance page"
	| contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/data/{3}/{4}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	gsFile := GsFile openOnServer: ((self apiConfiguration getInstancesPathFor: formName in: app), definitionId, '-', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceLayer methodsFor: 'service-get' stamp: 'BrunoBB 09/06/2015 14:32'!
sendFileForInstance: formName app: app fileId: fileId
	"This service is called when Orbeon requires a Custom PDF of a form or the Form Instance has any attachments and the user has clicked -Send-"
	| definition contents gsFile |
	<get>
	<produces: 'application/octet-stream'>
	<path: '/crud/{2}/{1}/form/{3}'>

	self requestContext response contentType: WAMimeType applicationOctetStream.

	definition := OrbeonApplication formDefinitionNamed: formName in: app.

	gsFile := GsFile openOnServer: ((self apiConfiguration getPublishedDefinitionsPathFor: formName in: app), definition id, '-', fileId) mode: 'rb'.
	contents := gsFile contentsAsUtf8.

	gsFile close.

	^contents! !

!WAOrbeonPersistenceLayer methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 13:03'!
storeFileOnTempPath: fileId definitionId: definitionId
	"The receiver store the file with id <fileId> belonging to the form definition with id <definitionId> in the temporary path.
	This method is called when a Form Definition has attachments and is save at once with the attachments.
	In this case the OrbeonFormDefinition has not been created and we can not get the current path to store files so we store them in the temp path.
	See issue #37 and is caused because Orbeon first call a service to store attachments and then call a service to store XML definition"
	| gsFile |

	gsFile := GsFile open: (self apiConfiguration getTempPath,'/', definitionId, '-', fileId, '.bin') mode: 'wb' onClient: false.

	gsFile
		nextPutAll: self requestContext request rawBody;
		flush;
		close.! !

!WAOrbeonPersistenceLayer methodsFor: 'service-put' stamp: 'BrunoBB 09/03/2015 11:59'!
unpublishFormDefinition: formName app: app
	"This method is called by Orbeon when a Form Definition has been unpublished with form name <formName> in application <app>"
	| application definition |
	<put>
	<path: '/crud/{2}/{1}/form/form.xhtml'>

	application := OrbeonApplication applicationNamed: app ifNone: [^NoOrbeonAppException signal: 'No such application [', app, ']'].
	definition := application definitionNamed: formName ifNone: [^NoOrbeonFormException signal: 'No such form [', formName, '] in application [', app, ']'].

	definition switchAvailable! !

Object subclass: #OrbeonApiConfiguration
	instanceVariableNames: 'isEnabled deferredXmlProcessing bpmForms pathForAttachments baseAttachmentPath tempAttachmentPath searchTypes'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Orbeon_Persistence_API'!

!OrbeonApiConfiguration commentStamp: 'BrunoBB 09/15/2015 14:20' prior: 0!
baseAttachmentPath - includes 5 subdirectories

Save Definitions (not been published yet)
baseAttachmentPath/definitions/saved

Published Definitions 
baseAttachmentPath/definitions/published

Forms Drafts 
baseAttachmentPath/drafts

Forms Instances
baseAttachmentPath/instances

Temporary (used as general repository for saved definitions - issue #37)
baseAttachmentPath/temp!

!OrbeonApiConfiguration class methodsFor: 'other' stamp: 'BrunoBB 09/01/2015 12:34'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonApiConfiguration class methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 12:57'!
initialize

	super initialize.

	Default := super new initialize! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 14:30'!
baseAttachmentPath
	^baseAttachmentPath! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 14:30'!
baseAttachmentPath: newValue
	baseAttachmentPath := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 12:51'!
bpmForms
	^bpmForms! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 12:51'!
bpmForms: newValue
	bpmForms := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 17:48'!
deferredXmlProcessing
	^deferredXmlProcessing! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 17:48'!
deferredXmlProcessing: newValue
	deferredXmlProcessing := newValue! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 14:31'!
getBasePathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"

	^(pathForAttachments at: appName ifAbsent: [^baseAttachmentPath])
		at: formName ifAbsent: [baseAttachmentPath]! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 14:35'!
getDraftsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'drafts/'! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 14:35'!
getInstancesPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'instances/'! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 14:36'!
getPublishedDefinitionsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'definitions/published/'! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 14:34'!
getSavedDefinitionsPathFor: formName in: appName
	"The receiver answer the base path where attachment of form <formName> in application <appName> are stored"


	^(self getBasePathFor: formName in: appName), 'definitions/saved/'! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/08/2015 13:24'!
getTempPath
	"Answer the temp path to store save definitions. See issue #37"

	^baseAttachmentPath, 'temp'! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/15/2015 14:22'!
initialize

	super initialize.

	baseAttachmentPath := '/opt/orbeon-files/'.
	isEnabled := false.
	"some forms can be processed on demand others later. If <true> is deferred processing if <false> is on demand"
	deferredXmlProcessing := Dictionary new. 
	bpmForms := Dictionary new. "some forms are used in the BPM application others not (only as regular Orbeon Forms) "
	pathForAttachments := Dictionary new. "the path to store attachments of the forms"
	searchTypes := Dictionary new. "the search type of each form when a search has more than one value (#or #and)"! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:36'!
isDeferredProcessing: formName in: appName
	"Answer whether of not the form named <formName> in the application <appName> has deferred XML processing
	If value is <true> then the XML processing is deferred"

	^(deferredXmlProcessing at: appName ifAbsent: [^false])
		at: formName ifAbsent: [^false]! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 08/26/2015 17:49'!
isEnabled
	^isEnabled! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 08/26/2015 17:49'!
isEnabled: newValue
	isEnabled := newValue! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 13:35'!
isOnDemandProcessing: formName in: appName
	"Answer whether of not the form named <formName> in the application <appName> has on demand XML processing
	If value is <false> then the XML processing is on demand"

	^((deferredXmlProcessing at: appName ifAbsent: [^true])
		at: formName) not! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/03/2015 12:54'!
pathForAttachments
	^pathForAttachments! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/03/2015 12:54'!
pathForAttachments: newValue
	pathForAttachments := newValue! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/15/2015 14:22'!
searchTypes
	^searchTypes! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/15/2015 14:22'!
searchTypes: newValue
	searchTypes := newValue! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/15/2015 15:18'!
setAndTypeSearchFor: formName in: appName
	"The receiver set the type search as AND for the form definition named <formName> in the application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^(searchTypes at: appName ifAbsentPut: [Dictionary new])
		at: formName put: true! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 13:36'!
setDeferredProcessingFor: formName in: appName
	"The receiver set the XML processing as -Deferred- for the form named <formName> in the applicacion named <appName> "

	^(deferredXmlProcessing at: appName ifAbsentPut: [Dictionary new])
		at: formName put: true! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 13:36'!
setOnDemandProcessingFor: formName in: appName
	"The receiver set the XML processing as -On Demand- for the form named <formName> in the applicacion named <appName> "

	^(deferredXmlProcessing at: appName ifAbsentPut: [Dictionary new])
		at: formName put: false! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/15/2015 15:18'!
setOrTypeSearchFor: formName in: appName
	"The receiver set the type search as OR for the form definition named <formName> in the application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^(searchTypes at: appName ifAbsentPut: [Dictionary new])
		at: formName put: false! !

!OrbeonApiConfiguration methodsFor: 'other' stamp: 'BrunoBB 09/03/2015 13:58'!
setPath: aPath for: formName in: appName
	"The receiver set the path <aPath> to store forms attachment for form named <formName> in the application <appName> "

	^(pathForAttachments at: appName ifAbsentPut: [Dictionary new])
		at: formName put: aPath! !

!OrbeonApiConfiguration methodsFor: 'Accessing' stamp: 'BrunoBB 09/15/2015 14:22'!
tempAttachmentPath
	^tempAttachmentPath! !

!OrbeonApiConfiguration methodsFor: 'Updating' stamp: 'BrunoBB 09/15/2015 14:22'!
tempAttachmentPath: newValue
	tempAttachmentPath := newValue! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/16/2015 10:31'!
typeSearchIsAnd: formName in: appName
	"Answer whether or not the type search is AND for the form definition <formName> in application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^((searchTypes at: appName ifAbsent: [^false])
		at: formName ifAbsent: [^false]) == true! !

!OrbeonApiConfiguration methodsFor: 'search type' stamp: 'BrunoBB 09/16/2015 10:30'!
typeSearchIsOr: formName in: appName
	"Answer whether or not the type search is OR for the form definition <formName> in application named <appName>.
	false - is OR
	true - is AND
	by default is OR"

	^((searchTypes at: appName ifAbsent: [^true])
		at: formName ifAbsent: [^true]) == false! !

Object subclass: #OrbeonDeferredProcessingQueue
	instanceVariableNames: 'instances'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Orbeon_Persistence_API'!

!OrbeonDeferredProcessingQueue class methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:57'!
default

	Default ifNil: [Default := super new initialize].

	^Default! !

!OrbeonDeferredProcessingQueue class methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:57'!
initialize

	super initialize.

	Default := super new initialize! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 14:39'!
addDeferredInstance: anOrbeonFormInstance

	^instances add: anOrbeonFormInstance! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/11/2015 15:07'!
initialize

	super initialize.

	instances := RcIdentityBag new.! !

!OrbeonDeferredProcessingQueue methodsFor: 'Accessing' stamp: 'BrunoBB 09/01/2015 12:33'!
instances
	^instances! !

!OrbeonDeferredProcessingQueue methodsFor: 'Updating' stamp: 'BrunoBB 09/01/2015 12:33'!
instances: newValue
	instances := newValue! !

!OrbeonDeferredProcessingQueue methodsFor: 'other' stamp: 'BrunoBB 09/13/2015 12:43'!
processInstances
	"The receiver process the unprocessed instances <OrbeonFormInstance>.	
	The instance variable <instances> is modified by various concurrent gem process"
	| processedInstances |
	
	processedInstances  := OrderedCollection new.
	instances do: [:each | 
		each processXML.
		processedInstances add: each].

	processedInstances do: [:each | instances remove: each ifAbsent: []]! !

Object subclass: #OrbeonMaintenanceScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Persistence_API'!

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/05/2015 17:01'!
deleteUnusedDefinitionOSFiles
	"The receiver delete all unused files of Form Definitions from OS file system"

	self deleteUnusedOSFiles: self getDefinitionUsedAttachmentIDs pathSelector: #getPublishedDefinitionsPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/06/2015 13:05'!
deleteUnusedInstanceDefinitionOSFiles
	"The receiver delete all unused files of Form Instance Definitions from OS file system"

	self deleteUnusedOSFiles: self getDefinitionUsedAttachmentIDs pathSelector: #getSavedDefinitionsPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/06/2015 13:33'!
deleteUnusedInstanceOSFiles
	"The receiver delete all unused files of Form Instances from OS file system"

	self deleteUnusedOSFiles: self getInstancesUsedAttachmentIDs pathSelector: #getInstancesPathFor:in:! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/06/2015 13:09'!
deleteUnusedOSFiles: usedDictionaryIds pathSelector: pathSelector
	"Delete unused OS files from calculated <pathSelector> that are no included in the dictionary <usedDictionaryIds>.
	<usedDictionaryIds> key is (app.formName) and value is a collection of ids."

	usedDictionaryIds keysAndValuesDo: [:appForm :collectionId | | path app form currentFiles |
		app := (appForm subStrings: '.') first.
		form := (appForm subStrings: '.') second.
		path := OrbeonApiConfiguration default perform: pathSelector with: form with: app."get tha path for <app> and <form>"
		currentFiles := ((GsFile contentsOfDirectory: path onClient: false) "get all current files in <path>"
			reject: [:eachPathFile | ((eachPathFile subStrings: '/') last = '.') or: [(eachPathFile subStrings: '/') last = '..']])
			collect: [:each | (each subStrings: '/') last].
		"remove files from <path> that are not included in <collectionId> block argument"
		currentFiles do: [:eachPathFile | (collectionId includes: eachPathFile) ifFalse: [GsFile removeServerFile: path, eachPathFile]].
	]! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/05/2015 16:45'!
getDefinitionUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	OrbeonApplication cache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry currentVersions do: [:eachDef | 
				allAttachmentIds at: (eachApp app, '.', eachDef form) 
					ifAbsent: [allAttachmentIds at: (eachApp app, '.', eachDef form) put: (OrderedCollection withAll: eachDef attachments)]
					ifPresent: [:collection | collection addAll: eachDef attachments].
			].
			registry oldVersions do: [:eachDef | 
				allAttachmentIds at: (eachApp app, '.', eachDef form) 
					ifAbsent: [allAttachmentIds at: (eachApp app, '.', eachDef form) put: (OrderedCollection withAll: eachDef attachments)]
					ifPresent: [:collection | collection addAll: eachDef attachments].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/05/2015 16:45'!
getInstanceDefinitionUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	OrbeonApplication cache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry savedDefinitions do: [:eachInstDef | 
				allAttachmentIds at: (eachInstDef app, '.', eachInstDef form) 
					ifAbsent: [allAttachmentIds at: (eachApp app, '.', eachInstDef form) put: (OrderedCollection withAll: eachInstDef attachments)]
					ifPresent: [:collection | collection addAll: eachInstDef attachments].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'os files' stamp: 'BrunoBB 09/05/2015 09:29'!
getInstancesUsedAttachmentIDs
	"Answer a dictionary of all used attachment's ids. Where the key is <app.formName> and the value is the actual collection"
	| allAttachmentIds |

	allAttachmentIds := Dictionary new.

	OrbeonApplication cache do: [:eachApp | 
		eachApp definitionRegistry keysAndValuesDo: [:formName :registry |

			registry currentVersions do: [:eachDef | 
				eachDef instances do: [:eachInst | 
					allAttachmentIds at: (eachApp app, '.', eachDef form)
						ifAbsent: [allAttachmentIds at: (eachApp app, '.', eachDef form) put: (OrderedCollection withAll: eachInst getAttachmentIds)]
						ifPresent: [:collection | collection addAll: eachInst getAttachmentIds]].
			].
			registry oldVersions do: [:eachDef | 
				eachDef instances do: [:eachInst | 
					allAttachmentIds at: (eachApp app, '.', eachDef form)
						ifAbsent: [allAttachmentIds at: (eachApp app, '.', eachDef form) put: (OrderedCollection withAll: eachInst getAttachmentIds)]
						ifPresent: [:collection | collection addAll: eachInst getAttachmentIds]].
			].
		].
	].

	^allAttachmentIds! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 09/06/2015 13:34'!
physicallyRemoveFormDefinitions
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormDefinitions where <deleted> is 'Y' "

	(OrbeonApplication getAllFormDefinitions select: [:each | each deleted = 'Y']) do: [:each | 
		each getApplication removeDefinition: each]! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 09/06/2015 13:34'!
physicallyRemoveFormInstanceDefinitions
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormInstanceDefinitions where <deleted> is 'Y' "

	(OrbeonApplication getAllSavedDefinitions select: [:each | each deleted = 'Y']) do: [:each | 
		each getApplication removeInstanceDefinition: each]! !

!OrbeonMaintenanceScript class methodsFor: 'forms' stamp: 'BrunoBB 09/06/2015 13:34'!
physicallyRemoveFormInstances
	"WARNING AFTER EXECUTING THIS METHOD THE OBJECTS ARE NOT RECOVERABLE ANY MORE"
	"This is a Time and Resource consuming Operation"
	"Remove all FormInstances where <deleted> is 'Y' "

	(OrbeonApplication getAllInstances select: [:each | each deleted = 'Y']) do: [:each | 
		each definition removeInstance: each]! !

Object subclass: #OrbeonQueryNode
	instanceVariableNames: 'name path type control searchField summaryField match value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Persistence_API'!

OrbeonQueryNode class
	instanceVariableNames: 'cache'!

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
control
	^control! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
control: newValue
	control := newValue! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 12:11'!
isSearchAndHasValue

	^(searchField = 'true') and: [value notNil]! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 12:33'!
isSummary

	^summaryField = 'true'! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
match
	^match! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
match: newValue
	match := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
name
	^name! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
name: newValue
	name := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
path
	^path! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
path: newValue
	path := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
searchField
	^searchField! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
searchField: newValue
	searchField := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
summaryField
	^summaryField! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
summaryField: newValue
	summaryField := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
type
	^type! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
type: newValue
	type := newValue! !

!OrbeonQueryNode methodsFor: 'Accessing' stamp: 'BrunoBB 08/08/2015 11:56'!
value
	^value! !

!OrbeonQueryNode methodsFor: 'Updating' stamp: 'BrunoBB 08/08/2015 11:56'!
value: newValue
	value := newValue! !

Object subclass: #OrbeonSearchApi
	instanceVariableNames: 'formDefinition xmlSearchDefinitionDocument user group resultCollection total searchTotal pageNumber pageSize queryNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Orbeon_Persistence_API'!

OrbeonSearchApi class
	instanceVariableNames: 'cache'!

!OrbeonSearchApi class methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
cache
	^cache! !

!OrbeonSearchApi class methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
cache: newValue
	cache := newValue! !

!OrbeonSearchApi class methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:45'!
form: anOrbeonFormDefinition

	^super new initialize
		formDefinition: anOrbeonFormDefinition;
		yourself! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:53'!
apiConfiguration

	^OrbeonApiConfiguration default! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:56'!
createGsQueriesFor: collectionOfOrbeonQueryNode
	"The receiver answer a Dictionary of GsQuery from the collection <collectionOfOrbeonQueryNode> of query nodes <OrbeonQueryNode>.
	The dictionary's keys is the name of the field and the value is the GsQuery"
	| nodesWithQuery gsQueries |

	gsQueries := Dictionary new.
	nodesWithQuery := collectionOfOrbeonQueryNode select: [:each | each isSearchAndHasValue].
	nodesWithQuery isEmpty ifTrue: [^#()].

	nodesWithQuery do: [:each | | stream |
		stream := PrintStream on: String new.
		((formDefinition stTypeOf: each name) == String)
		ifTrue: [stream nextPutAll: 'each.value = ''', each value, ''' & ']
		ifFalse: [stream nextPutAll: 'each.value = ', each value, ' & '].
		gsQueries at: each name put: (GsQuery fromString: (stream contents allButLast: 3))].

	^gsQueries! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
createQueryNodes
	"The receiver extract the -query nodes- from the XML Document <xmlDocument>.
	These -query nodes- are used to query the Orbeon Summary and to show summary fields"

	queryNodes := OrderedCollection new.

	(xmlSearchDefinitionDocument allElementsNamed: 'query') do: [:node | | queryNode value |
		value := node strings notEmpty ifTrue: [node strings last] ifFalse: [nil].
		queryNode := OrbeonQueryNode new name: (node attributeAt: 'name');
								path: (node attributeAt: 'path');
								type: (node attributeAt: 'type');
								control: (node attributeAt: 'control');
								searchField: (node attributeAt: 'search-field'); 
								summaryField: (node attributeAt: 'summary-field'); 
								match: (node attributeAt: 'match'); 
								value: value;
								yourself.
		queryNodes add: queryNode.
		].

	^queryNodes! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:34'!
executeQuery
	"The receiver execute the query defined in it's self. Storing the result in <resultCollection>"

	(queryNodes allSatisfy: [:each | each value == nil]) 
	ifTrue: [^self executeQueryWithoutSearchCriteria].

	^self executeQueryWithSearchCriteria! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:43'!
executeQueryWithoutSearchCriteria
	| drafts formsInRange stream instancesShift draftsSize draftsNodes draftNode |

	drafts :=  formDefinition getAllDraftsFor: user orGroup: group.
	formsInRange := OrderedCollection new.	
	stream := ReadStream on: formDefinition instances keys.
	instancesShift := (self pageFrom = 1) ifTrue: [1] ifFalse: [self pageFrom - drafts size].
	draftsSize :=  (self pageFrom = 1) ifTrue: [drafts size] ifFalse: [0].
	stream skip: instancesShift - 1.
	[stream atEnd not and:[(formsInRange size + draftsSize) < self getInstancesPerPage]] whileTrue: [ | form |
		form := formDefinition instances at: stream next.
		(form deleted = 'N' and: [(form hasUser: user readAccessUsing: formDefinition permissions) 
											or: [form hasRole: group readAccessUsing: formDefinition permissions]])
		ifTrue: [formsInRange add: form].
	].
	total := stream size + drafts size.
	stream close.
	draftsNodes := xmlSearchDefinitionDocument descendentElementsNamed: 'drafts'.
	draftsNodes isEmpty 
	ifTrue: [^resultCollection :=  (self pageFrom = 1) ifTrue: [drafts, formsInRange] ifFalse: [formsInRange]].

	draftNode := draftsNodes first.
	(((draftNode attributeAt: 'for-never-saved-document') = 'true') and: [draftNode contentString = 'only']) "drafts to display"
	ifTrue: [total := drafts size.
		^resultCollection := drafts].

	^resultCollection :=  (self pageFrom = 1) ifTrue: [drafts, formsInRange] ifFalse: [formsInRange]! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:56'!
executeQueryWithSearchCriteria
	"The receiver answer a collection with the result of applying the collection of queries to the form definition <anOrbeonFormDefinition>"
	| gsQueries result andResult orResult |

	result := Dictionary new.
	"create all <GsQuery> for each field with a search value"
	gsQueries := self createGsQueriesFor: queryNodes. "aDictionary (fieldName-->aGsQuery)"

	gsQueries keysAndValuesDo: [:fieldName :gsQuery | | rcIdentitySet |
		rcIdentitySet := formDefinition fieldInstancesOf: fieldName."get the collection of ALL field's values of <fieldName>"
		gsQuery on: rcIdentitySet. "set the collection of the <GsQuery>"
		result at: fieldName put: gsQuery queryResult.]."Excecute the <GsQuery> and store it on dictionary <result>"

	result isEmpty ifTrue: [^OrderedCollection new].

	"perform an OR search if OR is setted - (OR or AND search is useful when the search has more than one search criteria)"
	(self apiConfiguration typeSearchIsOr: formDefinition form in: formDefinition app) 
	ifTrue: [orResult := Set new.
		result do: [:queryResult | orResult addAll: queryResult].
		orResult  := (orResult collect: [:each | each form]) asOrderedCollection.
		^self filterAuthorizedInstancesIn: orResult "filter by permissions"].

	"perform an AND search"
	andResult := (OrderedCollection withAll: (result at: result keys asArray first)) collect: [:each | each form].

	result asOrderedCollection allButFirst do: [:queryResult | andResult := andResult intersection: (queryResult collect: [:each | each form])].
	"filter by permissions"
	^self filterAuthorizedInstancesIn: andResult asOrderedCollection! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:55'!
filterAuthorizedInstancesIn: anOrderedCollection
	"The receiver filter the form instances in <anOrderedCollection>. 
	Each instance in <anOrderedCollection> is checked if it has read authotization for user <username> or group <group> using the permissions defined in <anOrbeonFormDefinition>"

	^resultCollection := (anOrderedCollection select: [:each | 
														each deleted = 'N' and: 
															[(each hasUser: user readAccessUsing: formDefinition permissions) 
																or: [each hasRole: group readAccessUsing: formDefinition permissions]]])! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
formDefinition
	^formDefinition! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
formDefinition: newValue
	formDefinition := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:37'!
getInstancesPerPage

	^self pageTo - self pageFrom + 1! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
getPageNumber
	"The receiver extract the page number from the XMLDocument <xmlDocument>.
	This number is used for paging forms in Orbeon web pages.
	The page number is the current page to show.
	For example with paging (1 2 3 4 5) pages each index with 10 forms --> page number = 3 --> display pages from 30 to 39"
	| pageNumberNodes pageNumberNode |

	pageNumberNodes := xmlSearchDefinitionDocument allElementsNamed: 'page-number'.
	pageNumberNodes isEmpty ifTrue: [^pageNumber := 1].

	pageNumberNode := pageNumberNodes last.
	pageNumberNode strings isEmpty ifTrue: [^pageNumber := 1].

	^pageNumber := Number fromString: pageNumberNode strings last! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
getPageSize
	"The receiver extract the page size from the xml document <xmlDocument>.
	The page size set how many forms are displayed in a single page.
	This number is used for paging Orbeon Forms in Summaries"
	| pageSizeNodes pageSizeNode |

	pageSizeNodes := xmlSearchDefinitionDocument allElementsNamed: 'page-size'.
	pageSizeNodes isEmpty ifTrue: [^pageSize := 10].

	pageSizeNode := pageSizeNodes last.
	pageSizeNode strings isEmpty ifTrue: [^pageSize := 10].

	^pageSize := Number fromString: pageSizeNode strings last! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
group
	^group! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
group: newValue
	group := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
pageFrom
	"The receiver answer the start page to display search results"

	^self pageTo - pageSize + 1! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
pageNumber
	^pageNumber! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
pageNumber: newValue
	pageNumber := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
pageSize
	^pageSize! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
pageSize: newValue
	pageSize := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
pageTo
	"The receiver answer the top limit page to display search results"

	^pageSize * pageNumber! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
queryNodes
	^queryNodes! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
queryNodes: newValue
	queryNodes := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
resultCollection
	^resultCollection! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
resultCollection: newValue
	resultCollection := newValue! !

!OrbeonSearchApi methodsFor: 'other' stamp: 'BrunoBB 09/18/2015 10:28'!
resultSize

	^resultCollection size! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
searchTotal
	^searchTotal! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
searchTotal: newValue
	searchTotal := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
total
	^total! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
total: newValue
	total := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
user
	^user! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
user: newValue
	user := newValue! !

!OrbeonSearchApi methodsFor: 'Accessing' stamp: 'BrunoBB 09/18/2015 10:28'!
xmlSearchDefinitionDocument
	^xmlSearchDefinitionDocument! !

!OrbeonSearchApi methodsFor: 'Updating' stamp: 'BrunoBB 09/18/2015 10:28'!
xmlSearchDefinitionDocument: newValue
	xmlSearchDefinitionDocument := newValue! !
OrbeonApiConfiguration initialize!
OrbeonDeferredProcessingQueue initialize!
